Skip to navigation

Retrieve an invoice

View as Markdown
Retrieve the details of a specific Invoice object.

Authentication

AuthorizationBearer

Use Bearer {{token}} in the Authorization header for authentication.

Path parameters

keystringRequired
Object ID or Number.

Headers

Idempotency-KeystringOptional<=255 characters
Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
Accept-EncodingstringOptional

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-EncodingstringOptional

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Track-IdstringOptional<=64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Zuora-Entity-IdsstringOptional

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-IdsstringOptional

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.

Zuora-VersionstringOptional

The minor API version.

For a list of available minor versions, see API upgrades.

Query parameters

pageSizeintegerOptional1-99Defaults to 10

The maximum number of results to return in a single page. If the specified pageSize is less than 1 or greater than 99, Zuora will return a 400 error.

cursorstringOptional

A cursor for use in pagination. A cursor defines the starting place in a list. For instance, if you make a list request and receive 100 objects, ending with next_page=W3sib3JkZXJ=, your subsequent call can include cursor=W3sib3JkZXJ= in order to fetch the next page of the list.

sort[]list of stringsOptional

A case-insensitive query parameter that specifies the sort order of the list, which can be either ascending (e.g. accountnumber.ASC) or descending (e.g. accountnumber.DESC). You cannot sort on properties in arrays. If the array-type properties are specified for the sort[] parameter, they are ignored.

expand[]list of enumsOptional
Allows you to expand responses by including related object information in a single call.
filter[]list of stringsOptional

A case-insensitive filter on the list.

fields[]list of stringsOptional

A case-insensitive query parameter that allows you to specify which fields are returned in the response.

includeNullFieldsbooleanOptionalDefaults to false

Specifies whether to include fields with the null value in the response.

  • If set to true, all fields will be returned in the response, including those with the null value.
  • If set to false, only fields with non-null values will be returned.

Response headers

Content-EncodingstringOptional

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
RateLimit-LimitstringOptional

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingdouble

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetdouble

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-IdstringOptional
The Zuora internal identifier of the API call. You cannot control the value of this header.
Zuora-Track-IdstringOptional
A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.
Concurrency-Limit-TypestringOptional

The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.

For more information, see Concurrent request limits.

Concurrency-Limit-Limitinteger

The total number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Concurrency-Limit-Remaininginteger

The remaining number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Response

OK
idstringOptional
The unique identifier of the invoice.
createdByIdstringOptional
The unique identifier of the user who created the invoice.
createdDatedatetimeOptional

The time that the invoice gets created in the system, in the YYYY-MM-DD HH:MM:SS format.

updatedByIdstringOptional
The unique identifier of the user who last updated the invoice.
updatedDatedatetimeOptional

The time that the invoice gets updated in the system, in the YYYY-MM-DD HH:MM:SS format.

accountIdstringOptional
The ID of the customer account associated with the invoice.
adjustmentAmountdoubleOptional
The amount of the invoice adjustments associated with the invoice.
amountdoubleOptional
The total amount of the invoice.
amountWithoutTaxdoubleOptional
The invoice amount excluding tax.
autoPaybooleanOptional
Whether invoices are automatically picked up for processing in the corresponding payment run.
balancedoubleOptional
The remaining balance of the invoice after all payments, adjustments, and refunds are applied.
billToContactIdstringOptional

The ID of the bill-to contact associated with the invoice.

billToContactSnapshotIdstringOptional

The ID of the bill-to contact snapshot associated with the invoice.

commentsstringOptional
Comments about the invoice.
creditBalanceAdjustmentAmountdoubleOptional

The currency amount of the adjustment applied to the customer’s credit balance.

Note: This field is only available if you have the Credit Balance feature enabled and the Invoice Settlement feature disabled.

creditMemoAmountdoubleOptional

The currency amount of all credit memos applied to this invoice.

Note: This field is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information.

currencystring or nullOptional

The currency of the invoice.

Note: By default, the currency on a billing document matches the default currency set on the associated account. However, Zuora now offers a Multiple Currencies feature to support different currencies for billing documents, allowing flexibility beyond the account-level currency. For more information, see Multiple Currency.

dueDatedateOptional

The date by which the payment for this invoice is due, in yyyy-mm-dd format.

includesOneTimebooleanOptional

Specifies whether the invoice includes one-time charges.

includesRecurringbooleanOptional
Specifies whether the invoice includes recurring charges.
includesUsagebooleanOptional
Specifies whether the invoice includes usage charges.
invoiceDatedateOptional
The date that appears on the invoice being created.
invoiceNumberstringOptional
The unique identification number of the invoice.
lastEmailSentDatestringOptional
The date when the invoice was last emailed.
organizationIdstringOptional
ID of the organization this object belongs to.
paymentAmountdoubleOptional
The amount of payments applied to the invoice.
postedBystringOptional
The user ID of the person who moved the invoice to Posted status.
postedDatedatetimeOptional
The date when the invoice was posted.
refundAmountdoubleOptional
Specifies the amount of a refund that was applied against an earlier payment on the invoice.
sequenceSetIdstring or nullOptional
The ID of the sequence set associated with the invoice.
communicationProfileIdstring or nullOptional
The ID of the communication profile associated with the invoice.
shipToContactIdstringOptional

The ID of the ship-to contact associated with the invoice.

shipToContactSnapshotIdstringOptional

The ID of the ship-to contact snapshot associated with the invoice.

soldToContactIdstringOptional

The ID of the sold-to contact associated with the invoice.

soldToContactSnapshotIdstringOptional

The ID of the sold-to contact snapshot associated with the invoice.

sourceenumOptional
The source of the invoice.
Allowed values:
sourceIdstringOptional

The ID of the invoice source. If an invoice is generated from a bill run, the value is the number of the corresponding bill run.Otherwise, the value is null.

reversedbooleanOptional
Whether the invoice is reversed.
sourceTypeenumOptional
The type of the invoice source.
Allowed values:
statusenumOptional

The status of the invoice.

Note:

  • The Split status is applicable only when you use Split Invoice feature.

  • When an invoice is split, its status changes from Draft to Split, and the newly created invoices retain a reference to the original invoice.

Allowed values:
targetDatedateOptional
This date is used to determine which charges are to be billed. All charges that are to be billed on this date or prior will be included in this bill run.
taxAmountdoubleOptional
The amount of taxation.
taxExemptAmountdoubleOptional
The calculated tax amount excluded due to the exemption.
taxMessagestring or nullOptional
The message that the tax engine return if it calculates the taxes of this invoice fails.
taxStatusenumOptional

The status that the tax engine return after it calculates the taxes of this invoice. Also, the Voided status indicates that the tax transaction is successfully canceled on the tax vendor’s side. If a tax transaction was successfully committed to the third-party tax engine but the invoice failed to post, Zuora automatically detects the issue and voids the tax transaction on the vendor’s side.

templateIdstringOptional

The ID of the invoice template.

  • If you have the Flexible Billing Attributes feature enabled, the value of this field depends on the configuration of the invoice template.
    • If you specify an invoice template at the subscription level, the value of this field is automatically populated from the corresponding subscription.
    • If you do not specify any invoice template at the subscription level, the value of this field is automatically populated from the corresponding account.
  • If you have the Flexible Billing Attributes feature disabled, the value of this field is null.
transferredToAccountingenumOptional
Whether the invoice was transferred to an external accounting system.
Allowed values:
eInvoiceStatusenumOptional

It could be Processing, RetrieveTimeOut, Generated, Success, ConditionalSuccess, ApprovedByAuthority, Failed, and Rejected. If it’s Failed, it will have an error code and message. If it’s Generated or Success, both error code and message are empty, and eInvoiceFileId stores the file id of e-invoice.

eInvoiceFileIdstringOptional

The ID of the e-invoice file.

eInvoiceErrorCodestringOptional

The error code when status is Failed. This code can either be a Zuora-generated error code or one returned by a third-party e-invoice vendor.

eInvoiceErrorMessagestringOptional

The error message when status is “Failed”. This message can either be a Zuora-generated error code or one returned by a third-party e-invoice vendor.

paymentTermstringOptional
The payment term associated with the invoice. The payment term determines the due dates of invoices.
accountobjectOptional
billToContactobjectOptional
invoiceItemslist of objectsOptional
billToContactSnapshotobjectOptional
soldToContactSnapshotobjectOptional
shipToContactSnapshotobjectOptional

Errors

4XX
Client Request Error
500
Internal Server Error